package vocleditor.command;

import vocleditor.model.VOCLModelManager;
import VOCLModel.BendPoint;
import VOCLModel.VOCLModelFactory;

/**
 * 
 * Class       : CreateBendpointCommand<br/>
 * Package     : vocleditor.command<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : CreateBendpointCommand creates a new Bendpoint.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class CreateBendpointCommand extends BendpointCommand {
	BendPoint wbp;
	public void execute() {
		VOCLModelFactory mfc = VOCLModelManager.getFactory();
		wbp = mfc.createBendPoint();
		
		//Speichern der relative Position zur 1. ClassifierRole
		wbp.getH().add(new Integer(getFirstRelativeDimension().height));
		wbp.getW().add(new Integer(getFirstRelativeDimension().width));
		
		//Speichern der relativen Position zur 2. ClassifierRole
		wbp.getH().add(new Integer(getSecondRelativeDimension().height));
		wbp.getW().add(new Integer(getSecondRelativeDimension().width));
	
		//BendPoint hinzufgen
		getAssociationRole().getBendPoint().add(getIndex(), wbp);

	}

	public void undo() {
		getAssociationRole().getBendPoint().remove(wbp);
	}

}
