package vocleditor.command;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.commands.Command;

import vocleditor.model.Helpers;
import VOCLModel.VOCLExpression;

/**
 * 
 * Class       : DeleteVOCLExp<br/>
 * Package     : vocleditor.command<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 18.07.2004<br/>
 * Description : Command for deleting Constraints.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class DeleteVOCLExp extends Command {

	//the current VOCLExpression
	private VOCLExpression voclexpression;
	//the parent of this VOCLExpression (can be also a VOCLExpression or a Constraint)
	private EObject parent;
	
	/**
	 * Sets the current VOCLExpression
	 * @param expression
	 */
	public void setVoclexpression(VOCLExpression expression) {
		voclexpression = expression;
		//sets the parent of this VOCLExpression
		parent = voclexpression.eContainer();
	}
	
	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		Helpers.removeFromParent(parent,voclexpression.getIndex());
	}
	
	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		Helpers.addToParent(voclexpression,parent,voclexpression.getIndex());
	}
	
	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		execute();
	}
}
