/*
 * Created on 10.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package vocleditor.command;

import java.util.Iterator;
import java.util.List;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.eclipse.swt.widgets.Shell;

import vocleditor.dialogs.NewConstraintDialog;
import vocleditor.model.VOCLModelManager;
import VOCLModel.Constraint;
import VOCLModel.ConstraintKind;
import VOCLModel.Context;
import VOCLModel.VOCLDiagram;
import VOCLModel.VOCLModelFactory;
import VOCLModel.VariableDeclaration;

/**
 * @author Besitzer
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class EditConstraintCommand extends Command {
	//	 Label to show in editor palette
	private static final String label = "Constraint";

	// Description shown in the editor
	private static final String description = "Creates a new Constraint";

	// Data for execute()
	private Constraint constraint = null;

	private VariableDeclaration variableDeclaration = null;

	private List attributes = null;

	private Point loc;

	private VOCLDiagram parent;

	// To pop up the dialog, we need a reference to the parent shell...
	private Shell shell;

	/**
	 * Creates the command.
	 */
	public EditConstraintCommand() {
		super(label);
	}

	/**
	 * Creates the command and uses the given parent shell to display the dialog
	 * box.
	 * 
	 * @param shell
	 *            the shell.
	 */
	public EditConstraintCommand(Shell shell) {
		super(label);
		this.shell = shell;
	}

	/**
	 * Sets the parent of the Constraint.
	 * 
	 * @param newParent
	 *            the parent (VOCLDiagram)
	 */
	public void setParent(VOCLDiagram newParent) {
		parent = newParent;
	}

	/**
	 * Sets the current location of the Constraint.
	 * 
	 * @param loc
	 *            the location
	 */
	public void setLocation(Point loc) {
		this.loc = loc;
	}

	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	/**
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		NewConstraintDialog d = new NewConstraintDialog(shell);
		d.setEdit(true);
		d.setTitle("Edit this Constraint");
		d.setName(constraint.getName());
		if (constraint.getConstraintContext().getVariableDeclaration().size() > 0) {
			for (Iterator it = constraint.getConstraintContext()
					.getVariableDeclaration().iterator(); it.hasNext();) {
				VariableDeclaration vardec = (VariableDeclaration) it.next();
				d.setContext_name(vardec.getVarName());
				d.setContext_type(vardec.getType());
			}

		} else {
			d.setContext_type(constraint.getConstraintContext().getType());
		}
		d.setType(constraint.getKind().getName());
		d.open();
		if (d.isCancelled())
			return;

		String name = d.getName();
		String contextName = d.getContext_name();
		String contextTyp = d.getContext_type();
		String type = d.getType();

		VOCLModelFactory mfc = VOCLModelManager.getFactory();
		constraint.setName(name);
		if (type.equals("PRE"))
			constraint.setKind(ConstraintKind.PRE_LITERAL);
		else if (type.equals("POST"))
			constraint.setKind(ConstraintKind.POST_LITERAL);
		else
			constraint.setKind(ConstraintKind.INV_LITERAL);

		constraint.getConstraintContext().setType(contextTyp);
		constraint.getConstraintContext().setName(contextName);

		if (contextName.equals("")) {
			if (constraint.getConstraintContext().getVariableDeclaration()
					.size() > 0) {
				VariableDeclaration var = (VariableDeclaration) constraint
						.getConstraintContext().getVariableDeclaration().get(0);
				constraint.getConstraintContext().getVariableDeclaration()
						.remove(var);
			}
		} else {
			if (constraint.getConstraintContext().getVariableDeclaration()
					.size() > 0) {
				((VariableDeclaration) constraint.getConstraintContext()
						.getVariableDeclaration().get(0)).setType(contextTyp);
				((VariableDeclaration) constraint.getConstraintContext()
						.getVariableDeclaration().get(0))
						.setVarName(contextName);
			} else {
				VariableDeclaration var = mfc.createVariableDeclaration();
				var.setType(contextTyp);
				var.setVarName(contextName);
				constraint.getConstraintContext().getVariableDeclaration().add(
						var);
			}
		}
		insertIntoModel();
	}

	/**
	 * Insert all elements into modell.
	 */
	private void insertIntoModel() {
		parent.getConstraint().remove(constraint);
		parent.getConstraint().add(constraint);
		//add variable of context into modell
		//		if (variableDeclaration != null)
		//			constraint.getConstraintContext().getVariableDeclaration().add(
		//				variableDeclaration);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		insertIntoModel();
	}

	/**
	 * Sets the current Constraint.
	 * 
	 * @param cons
	 *            the current Constraint
	 */
	public void setConstraint(Constraint cons) {
		constraint = cons;
	}

	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		parent.getConstraint().remove(constraint);
	}
}