package vocleditor.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
/**
 * 
 * Class       : CreateLetExpressionDialog<br/>
 * Package     : vocleditor.dialog<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 04.07.2004<br/>
 * Description : This class provides a dialog in which you can create a Variable <br/>
 * 				for the Let-In-Expression<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class CreateLetExpressionDialog extends org.eclipse.swt.widgets.Dialog {
	private Shell dialogShell;
	private Label label1;
	private Label label4;
	private Text typeText;
	private Text varNameText;
	private Button isVertikal;
	private Button cancel;
	private Button Ok;
	private String varName;
	private String type;
	private boolean cancelled;
	private boolean isVertical;
	
	public CreateLetExpressionDialog(Shell parent, int style) {
		super(parent, style);
	}

	/** Auto-generated event handler method */
	protected void OkMouseDown(MouseEvent evt){
		cancelled = false;
		//name of the Variable
		varName = varNameText.getText();
		//type of the Variable
		type = typeText.getText();
		//alignment
		isVertical = isVertikal.getSelection();
		if (type == "" || varName == ""){
			MessageBox msg =
							new MessageBox(dialogShell, SWT.ICON_INFORMATION | SWT.OK);
						msg.setMessage(
							"Bitte geben Sie eine vollstndige Variablendefinition an.");
						msg.open();
						return;
		}
		dialogShell.close();
	}

	/** Auto-generated event handler method */
	protected void cancelMouseDown(MouseEvent evt){
		cancelled = true;
		dialogShell.close();
	}

	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			Ok = new Button(dialogShell,SWT.PUSH| SWT.CENTER);
			cancel = new Button(dialogShell,SWT.PUSH| SWT.CENTER);
			isVertikal = new Button(dialogShell,SWT.CHECK| SWT.LEFT);
			varNameText = new Text(dialogShell,SWT.NULL);
			typeText = new Text(dialogShell,SWT.NULL);
			label4 = new Label(dialogShell,SWT.NULL);
			label1 = new Label(dialogShell,SWT.NULL);
	
			dialogShell.setText("Create a Let-In-Expression");
			dialogShell.setSize(220, 175);
	
			Ok.setText("Ok");
			Ok.setSize(new org.eclipse.swt.graphics.Point(70,29));
			Ok.setBounds(new org.eclipse.swt.graphics.Rectangle(13,113,70,29));
			Ok.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					OkWidgetSelected(evt);
				}
			});
			Ok.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					OkMouseDown(evt);
				}
			});
	
			cancel.setText("Cancel");
			cancel.setSize(new org.eclipse.swt.graphics.Point(60,30));
			cancel.setBounds(new org.eclipse.swt.graphics.Rectangle(93,112,60,30));
			cancel.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					cancelMouseDown(evt);
				}
			});
	
			isVertikal.setText("vertical alignment");
			isVertikal.setSize(new org.eclipse.swt.graphics.Point(139,22));
			isVertikal.setBounds(new org.eclipse.swt.graphics.Rectangle(14,85,139,22));
	
			varNameText.setSize(new org.eclipse.swt.graphics.Point(115,16));
			varNameText.setBounds(new org.eclipse.swt.graphics.Rectangle(68,18,121,16));
	
			typeText.setSize(new org.eclipse.swt.graphics.Point(115,16));
			typeText.setBounds(new org.eclipse.swt.graphics.Rectangle(67,52,121,16));
	
			label4.setText("Type:");
			label4.setSize(new org.eclipse.swt.graphics.Point(45,17));
			label4.setBounds(new org.eclipse.swt.graphics.Rectangle(19,51,45,17));
	
			label1.setText("Variable:");
			label1.setSize(new org.eclipse.swt.graphics.Point(45,17));
			label1.setBounds(new org.eclipse.swt.graphics.Rectangle(17,17,45,17));
			dialogShell.setLayout(null);
			Rectangle bounds = dialogShell.computeTrim(0, 0, 220,153);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	public String getVarName(){
		return varName;
	}
	
	public String getType(){
		return type;
	}
	
	public boolean isVertical(){
		return isVertical;
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI(){
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI(){
	}

	/** Auto-generated main method */
	public static void main(String[] args){
		showGUI();
	}

	/**
	 * Indicates whether it is aborted or not.
	 * @return isCancelled
	 */
	public boolean isCancelled(){
		return cancelled;
	}
	/**
	* This static method creates a new instance of this class and shows
	* it inside a new Shell.
	*
	* It is a convenience method for showing the GUI, but it can be
	* copied and used as a basis for your own code.	*
	* It is auto-generated code - the body of this method will be
	* re-generated after any changes are made to the GUI.
	* However, if you delete this method it will not be re-created.	*/
	public static void showGUI(){
		try {
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			CreateLetExpressionDialog inst = new CreateLetExpressionDialog(shell, SWT.NULL);
			inst.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Auto-generated event handler method */
	protected void OkWidgetSelected(SelectionEvent evt){
		
	}
}
