package vocleditor.dialogs;

import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;

import vocleditor.model.Helpers;
import VOCLModel.Attribute;
import VOCLModel.ClassifierRole;
import VOCLModel.Condition;
import VOCLModel.Method;
import VOCLModel.NavExp;
import VOCLModel.VariableDeclaration;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
/**
 * 
 * Class       : AttributeDialogInterface<br/>
 * Package     : vocleditor.dialog<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : This class provides a dialog for creating / editing ClassifierRoles<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class CreateNewClassifierRoleSimpleDialog
	extends org.eclipse.swt.widgets.Dialog
	implements AttributeDialogInterface {
	private Label showMethod;
	private Button AddMethod;
	private TableColumn valueVarColumn;
	private TableColumn attrTypeComponent;
	private TableColumn attrNameColumn;
	private Table varList;
	private Label label3;
	private Text roleTypeText;
	private Button cancelButton;
	private Button okayButton;
	private Label label2;
	private Label label1;
	private Text roleNameText;
	private Button editButton;
	private Button removeButton;
	private Button addButton;
	private Shell dialogShell;
	private boolean isCanceled = false;
	private NavExp navexp;
	private ClassifierRole classifier;

	/**
	 * Constructor.
	 * @param parent
	 */
	public CreateNewClassifierRoleSimpleDialog(Shell parent) {
		super(parent, SWT.NULL);
	}

	/**
	 * Sets the parent of the NavigationExpression.
	 * @param navexp
	 */
	public void setParent(NavExp navexp) {
		this.navexp = navexp;
	}

	/**
	 * Indicates whether the dialog was aborted or not.
	 * @return isCancelled
	 */
	public boolean isCanceled() {
		return isCanceled;
	}

	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open() {
		try {
			preInitGUI();

			Shell parent = getParent();
			dialogShell =
				new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			addButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			removeButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			editButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			roleNameText = new Text(dialogShell, SWT.NULL);
			label1 = new Label(dialogShell, SWT.NULL);
			label2 = new Label(dialogShell, SWT.NULL);
			okayButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			cancelButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			roleTypeText = new Text(dialogShell, SWT.NULL);
			label3 = new Label(dialogShell, SWT.NULL);
			varList = new Table(dialogShell, SWT.NULL);
			attrNameColumn = new TableColumn(varList, SWT.NULL);
			attrTypeComponent = new TableColumn(varList, SWT.NULL);
			valueVarColumn = new TableColumn(varList, SWT.NULL);
			AddMethod = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			showMethod = new Label(dialogShell, SWT.NULL);

			dialogShell.setText("Create SimpleClassifierRole");
			dialogShell.setSize(332, 413);

			addButton.setText("&Add");
			addButton.setSize(new org.eclipse.swt.graphics.Point(60, 30));
			addButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(249, 113, 60, 30));
			addButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					addButtonMouseDown(evt);
				}
			});

			removeButton.setText("&Remove");
			removeButton.setSize(new org.eclipse.swt.graphics.Point(60, 30));
			removeButton.setEnabled(false);
			removeButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(249, 153, 60, 30));
			removeButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					removeButtonMouseDown(evt);
				}
			});

			editButton.setText("&Edit");
			editButton.setSize(new org.eclipse.swt.graphics.Point(60, 30));
			editButton.setEnabled(false);
			editButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(249, 193, 60, 30));
			editButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					editButtonMouseDown(evt);
				}
			});

			roleNameText.setSize(new org.eclipse.swt.graphics.Point(174, 20));
			roleNameText.setBounds(
				new org.eclipse.swt.graphics.Rectangle(100, 14, 180, 20));

			label1.setText("role name:");
			label1.setSize(new org.eclipse.swt.graphics.Point(70, 20));
			label1.setBounds(
				new org.eclipse.swt.graphics.Rectangle(30, 15, 70, 20));
			label1.setAlignment(SWT.RIGHT);

			label2.setText("attributes:");
			label2.setSize(new org.eclipse.swt.graphics.Point(63, 15));
			label2.setBounds(
				new org.eclipse.swt.graphics.Rectangle(29, 93, 63, 15));

			okayButton.setText("OK");
			okayButton.setSize(new org.eclipse.swt.graphics.Point(80, 30));
			okayButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(21, 375, 80, 30));
			okayButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					okayButtonMouseDown(evt);
				}
			});

			cancelButton.setText("Cancel");
			cancelButton.setSize(new org.eclipse.swt.graphics.Point(80, 30));
			cancelButton.setBounds(
				new org.eclipse.swt.graphics.Rectangle(120, 375, 80, 30));
			cancelButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					cancelButtonMouseDown(evt);
				}
			});

			roleTypeText.setSize(new org.eclipse.swt.graphics.Point(174, 20));
			roleTypeText.setBounds(
				new org.eclipse.swt.graphics.Rectangle(100, 49, 180, 20));

			label3.setText("role type:");
			label3.setAlignment(SWT.RIGHT);
			label3.setSize(new org.eclipse.swt.graphics.Point(70, 20));
			label3.setBounds(
				new org.eclipse.swt.graphics.Rectangle(24, 50, 70, 20));

			varList.setHeaderVisible(true);
			varList.setLinesVisible(true);
			varList.setSize(new org.eclipse.swt.graphics.Point(196, 161));
			varList.setBounds(
				new org.eclipse.swt.graphics.Rectangle(21, 117, 213, 178));
			varList.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					varListWidgetSelected(evt);
				}
			});

			attrNameColumn.setText("Name");
			attrNameColumn.setWidth(60);

			attrTypeComponent.setText("Typ");
			attrTypeComponent.setWidth(73);

			valueVarColumn.setText("Value/Variable");
			valueVarColumn.setWidth(80);

			AddMethod.setText("Add method");
			AddMethod.setSize(new org.eclipse.swt.graphics.Point(111, 30));
			AddMethod.setBounds(
				new org.eclipse.swt.graphics.Rectangle(21, 308, 111, 30));
			AddMethod.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					AddMethodMouseDown(evt);
				}
			});

			showMethod.setSize(new org.eclipse.swt.graphics.Point(298, 22));
			showMethod.setBounds(
				new org.eclipse.swt.graphics.Rectangle(24, 340, 298, 22));
			dialogShell.setLayout(null);
			Rectangle bounds = dialogShell.computeTrim(0, 0, 332, 413);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI() {
		isCanceled = false;
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI() {

		//fill the dialog with data when it is edited
		if (classifier != null) {
			//checks if the classifierRole has a VariableDeclaration for
			//the name and the role
			if (classifier.getClassifierVar() == null) {
				roleNameText.setText("");
				roleTypeText.setText(classifier.getType());
			} else {
				roleNameText.setText(
					classifier.getClassifierVar().getVarName());
				roleTypeText.setText(classifier.getClassifierVar().getType());
			}

			//checks if the classifierRole has attributes
			if (classifier.getAttribute().size() > 0) {
				for (Iterator it = classifier.getAttribute().iterator();
					it.hasNext();
					) {
					Attribute attr = (Attribute) it.next();
					TableItem item = new TableItem(varList, SWT.NULL);
					item.setText(0, attr.getName());
					attributes.add(attr.getName());
					item.setText(1, attr.getType());
					attributes.add(attr.getType());
					attributes.add(attr.getValue());

					if (!attr.getValue().equals("")) {
						item.setText(2, attr.getValue());
						attributes.add("");
					} else {
						item.setText(
							2,
							attr.getVariableDeclaration().getVarName());
						attributes.add(
							attr.getVariableDeclaration().getVarName());
					}
				}

			}
			
			if (classifier.getMethod() != null) {
				String rightSide = "";
				String leftSide = "";
				Method m = classifier.getMethod();
				methodName = m.getName();
				rightSide += methodName;
				if (m.getReturns() != null) {
					resultName = m.getReturns().getVarName();
					resultType = m.getReturns().getType();
					leftSide = resultName;
				}

				if (m.getCall().size() > 0) {
					parameters = new Vector();
					rightSide += " ( ";
					int i = 0;
					for (Iterator it = m.getCall().iterator();
						it.hasNext();
						i++) {
						if (i >= 1) {
							rightSide += ", ";
						}
						VariableDeclaration var =
							(VariableDeclaration) it.next();
						parameters.add(var.getVarName());
						rightSide += var.getVarName() + " : ";
						parameters.add(var.getType());
						rightSide += var.getType();

					}
					rightSide += " )";
				} else {
					rightSide += "()";
				}

				if (leftSide.equals("")) {
					showMethod.setText(rightSide);
				} else {
					showMethod.setText(leftSide + " = " + rightSide);
				}
			}
		}
	}

	/**
	* Auto-generated method
	*/
	public String getRoleNameText() {
		return classRoleName;
	}

	/**
	 * Sets the current ClassifierRole.
	 * @param classifier the current classifierRole
	 */
	public void setClassifierRole(ClassifierRole classifier) {
		this.classifier = classifier;
	}
	/**
	 * Returns the RoleType.
	 * @return the RoleType
	 */
	public String getRoleTypeText() {
		return type;
	}

	String classRoleName = "";
	String type = "";

	/**
	* Auto-generated method
	*/
	public Button getAddButton() {
		return addButton;
	}

	Vector attributes = new Vector();
	/** Auto-generated event handler method */
	protected void addButtonMouseDown(MouseEvent evt) {
		//adds attributes
		NewAttributeDialog d =
			new NewAttributeDialog(dialogShell, SWT.NULL, this, false);
		d.open();
		String name = d.getName();
		String value = d.getValue();
		String type = d.getType();
		String varName = d.getVarName();
		if (!d.isCancelled()) { //Okay was pressed ...
			addItem(name, type, value, varName);
		}
		removeButton.setEnabled(varList.getItemCount() != 0);
		editButton.setEnabled(varList.getItemCount() != 0);

	}

	/**
	 * adds attributes to a list and the table.
	 * @param name attributename
	 * @param type attributetype
	 * @param value attributevalue or 
	 * @param varName attributevariable
	 */
	public void addItem(
		String name,
		String type,
		String value,
		String varName) {
		TableItem tableItem = new TableItem(varList, SWT.NULL);
		tableItem.setText(0, name);
		tableItem.setText(1, type);
		tableItem.setText(2, value + varName);

		attributes.add(name);
		attributes.add(type);
		attributes.add(value);
		attributes.add(varName);
	}

	/**
	 * @see vocleditor.dialogs.AttributeDialogInterface#getAttributes()
	 */
	public Vector getAttributes() {
		return attributes;
	}

	/** Auto-generated event handler method */
	protected void okayButtonMouseDown(MouseEvent evt) {
		type = roleTypeText.getText();
		classRoleName = roleNameText.getText();

		if (type == "") {
			MessageBox msg =
				new MessageBox(dialogShell, SWT.ICON_INFORMATION | SWT.OK);
			msg.setText("Eingabe unvollstndig");
			msg.setMessage("Bitte geben Sie einen gltigen Rollentyp an.");
			msg.open();
			return;
		}

//		Condition cond = navexp.getCondition();
//		String links = cond.getLeft().getVarName();
//		String rechts = cond.getRight().getVarName();
//		if (cond != null) {
//			if (checkHasCondition(cond) && !attributes.contains(links)) {
//				MessageBox msg =
//					new MessageBox(dialogShell, SWT.ICON_INFORMATION | SWT.OK);
//				msg.setText("Variable ist an Condition gebunden");
//				msg.setMessage(
//					"Sie haben eine Variable verndert die an eine Condition "
//						+ "\ngebunden war. Sie mssen zuerst die Condition lschen und dann die Variable ndern");
//				msg.open();
//				return;
//			}
//		}

		if (!classRoleName.equals("") && navexp != null) {
			if (Helpers
				.checkVariableAlreadyExists(navexp, classRoleName, false)) {
				MessageBox box =
					new MessageBox(dialogShell, SWT.ICON_WARNING | SWT.OK);
				box.setText("Rollenname bereits vorhanden!");
				box.setMessage(
					"Die Variable "
						+ classRoleName
						+ " wurde bereits in diesem Navigationsausdruck definiert");
				box.open();
				return;
			}
		}

		for (int i = 0; i < attributes.size(); i += 4) {
			String name = (String) attributes.elementAt(i + 3);
			if (!name.equals("") && navexp != null) {
				if (Helpers.checkVariableAlreadyExists(navexp, name, true)) {
					MessageBox box =
						new MessageBox(dialogShell, SWT.ICON_WARNING | SWT.OK);
					box.setText("Variable schon vorhanden!");
					box.setMessage(
						"Die Variable "
							+ name
							+ " wurde bereits in diesem Navigationsausdruck definiert");
					box.open();
					return;
				}
			}

		}

		dialogShell.close();
	}

	protected void removeButtonMouseDown(MouseEvent evt) {
		int index = varList.getSelectionIndex();
		if (index < 0) {
			MessageBox msg = new MessageBox(dialogShell, SWT.ICON_INFORMATION);
			msg.setMessage("Selectieren Sie bitte ein Attribut");
			msg.setText("Keine Selektion");
			msg.open();
			return;
		}
		attributes.remove(index * 3);
		attributes.remove(index * 3);
		attributes.remove(index * 3);
		attributes.remove(index * 3);
		varList.remove(index);
		removeButton.setEnabled(varList.getItemCount() != 0);
		editButton.setEnabled(varList.getItemCount() != 0);

	}

	public NavExp getNavExp() {
		return navexp;
	}
	/** Auto-generated event handler method */
	protected void editButtonMouseDown(MouseEvent evt) {
		int index = varList.getSelectionIndex();
		if (index < 0) {
			MessageBox msg = new MessageBox(dialogShell, SWT.ICON_INFORMATION);
			msg.setMessage("Selectieren Sie bitte ein Attribut");
			msg.setText("Keine Selektion");
			msg.open();
			return;
		}
		NewAttributeDialog d =
			new NewAttributeDialog(dialogShell, SWT.NULL, this, true);
		d.setName((String) attributes.get(index * 4));
		d.setType((String) attributes.get(index * 4 + 1));
		d.setValue((String) attributes.get(index * 4 + 2));
		d.setVarName((String) attributes.get(index * 4 + 3));
		d.open();

		String name = d.getName();
		String value = d.getValue();
		String type = d.getType();
		String varName = d.getVarName();

		if (!name.equals("")) { //Okay was pressed ...
			editButton.setEnabled(true);
			TableItem tableItem = varList.getItem(index);
			tableItem.setText(0, name);
			tableItem.setText(1, type);
			tableItem.setText(2, value + varName);
			attributes.set(index * 4, name);
			attributes.set(index * 4 + 1, type);
			attributes.set(index * 4 + 2, value);
			attributes.set(index * 4 + 3, varName);
		}
	}

	/** Auto-generated event handler method */
	protected void cancelButtonMouseDown(MouseEvent evt) {
		isCanceled = true;
		dialogShell.close();
	}

	/** Auto-generated event handler method */
	protected void varListWidgetSelected(SelectionEvent evt) {
		editButton.setEnabled(true);
		removeButton.setEnabled(true);
	}

	private String methodName = null;
	private String resultName = "";
	private String resultType = null;
	private Vector parameters = new Vector();
	/** Auto-generated event handler method */
	protected void AddMethodMouseDown(MouseEvent evt) {
		//creates a new method
		NewMethodDialog d = new NewMethodDialog(dialogShell, SWT.NULL, this);
		d.open();
		if (d.isCancelled()) {
			return;
		}
		methodName = d.getMethod_Name();
		resultName = d.getResult_Name();
		resultType = d.getResult_Type();
		parameters = d.getParameters();
		if (parameters != null) {
			String param = "";
			for (int i = 0; i < parameters.size(); i += 2) {
				if (i < 2) {
					param += parameters.elementAt(i)
						+ " : "
						+ parameters.elementAt(i + 1);
				} else {
					param += ", "
						+ parameters.elementAt(i)
						+ " : "
						+ parameters.elementAt(i + 1);
				}

			}
			if (!resultName.equals(""))
				showMethod.setText(
					resultName + " = " + methodName + "( " + param + " )");
			else
				showMethod.setText(methodName + "( " + param + " )");
		} else {

			if (!resultName.equals(""))
				showMethod.setText(resultName + " = " + methodName + "()");
			else
				showMethod.setText(methodName + "()");
		}
	}
	/**
	 * Returns the Method as a String.
	 * @return method String
	 */
	public String getMethodName() {
		return methodName;
	}

	/**
	 * Returns the result name of the Method.
	 * @return result name
	 */
	public String getResultName() {
		return resultName;
	}

	/**
	 * Returns the result type of the Method.
	 * @return result tpye
	 */
	public String getResultType() {
		return resultType;
	}

	/**
	 * Returns the method parameters.
	 * @return parameters
	 */
	public Vector getParameters() {
		return parameters;
	}

	private boolean checkHasCondition(Condition condition) {
		boolean temp = false;

		if (condition != null) {
			VariableDeclaration v = condition.getLeft();
			//Checks if a Variable of an attribute is used in this condition
			List attrList = classifier.getAttribute();
			if (attrList.size() > 0) {
				Iterator it = attrList.iterator();
				while (it.hasNext()) {
					Attribute attr = (Attribute) it.next();
					if (attr != null) {
						if (attr.getVariableDeclaration() == v) {

							temp = true;
							;
						}
					}
				}
			}

			v = condition.getRight();
			if (v != null) {
				if (attrList.size() > 0) {
					Iterator it = attrList.iterator();
					while (it.hasNext()) {
						Attribute attr = (Attribute) it.next();
						if (attr != null) {
							if (attr.getVariableDeclaration() == v) {

								temp = true;
								;
							}
						}
					}
				}
			}

			if (classifier instanceof ClassifierRole) {
				//check if the variable of the method is used in the condition
				Method method = ((ClassifierRole) classifier).getMethod();
				if (method != null) {
					VariableDeclaration result = method.getReturns();
					if (result != null) {
						if (v == result) {
							temp = true;
						}
					}
				}
			}
		}
		return temp;
	}
}
