package vocleditor.dialogs;

import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import vocleditor.model.NavExpConstants;
import VOCLModel.VariableDeclaration;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
/**
 * 
 * Class       : NewConditionDialog<br/>
 * Package     : vocleditor.dialog<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 04.07.2004<br/>
 * Description : This class provides a dialog for creating a condition<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class NewConditionDialog extends org.eclipse.swt.widgets.Dialog {
	private Combo rightVariables;
	private Button asVarDec;
	private Text typeRightSide;
	private Text typeLeftSide;
	private Text rightValue;
	private Combo operator;
	private Combo leftVariables;
	private Label Operator;
	private Label right;
	private Label left;
	private Button Cancel;
	private Button OK;
	private Shell dialogShell;
	private List linkeVariablen;
	private String leftName;
	private String leftType;
	private String value;
	private String rightType;
	private String rightName;
	private String op;
	private boolean canceled = false;

	/**
	 * Constructor
	 * @param parent the parent (NavExp or Constraint)
	 * @param style
	 */
	public NewConditionDialog(Shell parent, int style) {
		super(parent, style);
	}

	/**
	 * Sets the collected variables for the left side.
	 * @param vars
	 */
	public void setLinkeVariablen(List vars) {
		linkeVariablen = vars;
	}

	/**
	 * Insert variables into the combobox.
	 */
	private void insertVariablen() {
		if (linkeVariablen.size() > 0) {
			for (int i = 0; i < linkeVariablen.size(); i++) {
				VariableDeclaration v =
					(VariableDeclaration) linkeVariablen.get(i);
				leftVariables.add(v.getVarName());
			}
			leftVariables.select(0);

			//search the type of the selected variable 
			String type =
				((VariableDeclaration) linkeVariablen.get(0)).getType();
			typeLeftSide.setText(type);
			typeRightSide.setText(type);
			typeRightSide.setVisible(asVarDec.getSelection());
			//insert variables on the rightside combobox apart from the variable
			//selected on the left side
			if (linkeVariablen.size() > 1) {
				for (int i = 0; i < linkeVariablen.size(); i++) {
					VariableDeclaration v =
						(VariableDeclaration) linkeVariablen.get(i);

					if (type.equals(v.getType())
						&& !v.getVarName().equals(leftVariables.getItem(0))) {
						rightVariables.add(v.getVarName());
					}
				}
			}
		} else {
			OK.setEnabled(false);
			typeRightSide.setVisible(false);
		}
	}

	/**
	* Opens the Dialog Shell.
	* Auto-generated code - any changes you make will disappear.
	*/
	public void open(){
		try {
			preInitGUI();
	
			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			OK = new Button(dialogShell,SWT.PUSH| SWT.CENTER);
			Cancel = new Button(dialogShell,SWT.PUSH| SWT.CENTER);
			left = new Label(dialogShell,SWT.NULL);
			right = new Label(dialogShell,SWT.NULL);
			Operator = new Label(dialogShell,SWT.NULL);
			leftVariables = new Combo(dialogShell,SWT.NULL);
			operator = new Combo(dialogShell,SWT.NULL);
			rightValue = new Text(dialogShell,SWT.NULL);
			typeLeftSide = new Text(dialogShell,SWT.NULL);
			typeRightSide = new Text(dialogShell,SWT.NULL);
			asVarDec = new Button(dialogShell,SWT.CHECK| SWT.LEFT);
			rightVariables = new Combo(dialogShell,SWT.NULL);
	
			dialogShell.setText("Create a condition");
			dialogShell.setSize(318, 239);
	
			OK.setText("OK");
			OK.setSize(new org.eclipse.swt.graphics.Point(60,30));
			OK.setBounds(new org.eclipse.swt.graphics.Rectangle(16,165,60,30));
			OK.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					OKMouseDown(evt);
				}
			});
	
			Cancel.setText("Cancel");
			Cancel.setSize(new org.eclipse.swt.graphics.Point(60,30));
			Cancel.setBounds(new org.eclipse.swt.graphics.Rectangle(86,165,60,30));
			Cancel.addMouseListener( new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					CancelMouseDown(evt);
				}
			});
	
			left.setText("left side");
			left.setSize(new org.eclipse.swt.graphics.Point(60,15));
			left.setBounds(new org.eclipse.swt.graphics.Rectangle(19,55,60,15));
	
			right.setText("right side");
			right.setSize(new org.eclipse.swt.graphics.Point(60,17));
			right.setBounds(new org.eclipse.swt.graphics.Rectangle(190,53,60,17));
	
			Operator.setText("operator");
			Operator.setSize(new org.eclipse.swt.graphics.Point(49,15));
			Operator.setBounds(new org.eclipse.swt.graphics.Rectangle(106,54,49,15));
	
			leftVariables.setSize(new org.eclipse.swt.graphics.Point(50,21));
			leftVariables.setEnabled(true);
			leftVariables.setBounds(new org.eclipse.swt.graphics.Rectangle(18,78,75,21));
			leftVariables.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					leftVariablesWidgetSelected(evt);
				}
			});
	
			operator.setSize(new org.eclipse.swt.graphics.Point(35,21));
			operator.setBounds(new org.eclipse.swt.graphics.Rectangle(106,79,60,21));
	
			rightValue.setSize(new org.eclipse.swt.graphics.Point(99,20));
			rightValue.setBounds(new org.eclipse.swt.graphics.Rectangle(193,80,105,20));
	
			typeLeftSide.setEditable(false);
			typeLeftSide.setSize(new org.eclipse.swt.graphics.Point(67,20));
			typeLeftSide.setBounds(new org.eclipse.swt.graphics.Rectangle(19,106,73,20));
			final Color typeLeftSidebackground = new Color(Display.getDefault(),239,239,239);
			typeLeftSide.setBackground(typeLeftSidebackground);
	
			typeRightSide.setEditable(false);
			typeRightSide.setSize(new org.eclipse.swt.graphics.Point(99,20));
			typeRightSide.setEnabled(false);
			typeRightSide.setBounds(new org.eclipse.swt.graphics.Rectangle(193,107,105,20));
			final Color typeRightSidebackground = new Color(Display.getDefault(),240,240,240);
			typeRightSide.setBackground(typeRightSidebackground);
	
			asVarDec.setText("as variable");
			asVarDec.setSize(new org.eclipse.swt.graphics.Point(92,30));
			asVarDec.setBounds(new org.eclipse.swt.graphics.Rectangle(194,134,92,30));
			asVarDec.addSelectionListener( new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					asVarDecWidgetSelected(evt);
				}
			});
	
			rightVariables.setSize(new org.eclipse.swt.graphics.Point(80,21));
			rightVariables.setBounds(new org.eclipse.swt.graphics.Rectangle(193,80,105,21));
			dialogShell.setLayout(null);
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					typeLeftSidebackground.dispose();
					typeRightSidebackground.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 318,203);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	/** Add your pre-init code in here 	*/
	public void preInitGUI() {
	}

	/** Add your post-init code in here 	*/
	public void postInitGUI() {
		insertVariablen();
		for (int i = 0; i < NavExpConstants.CONSTRAINT_OP_TYPES.length; i++) {
			operator.add(NavExpConstants.CONSTRAINT_OP_TYPES[i]);
		}
		operator.select(0);
	}

	private void showType() {

	}

	/** Auto-generated event handler method */
	protected void leftVariablesWidgetSelected(SelectionEvent evt) {
		int index = leftVariables.getSelectionIndex();
		String type =
			((VariableDeclaration) linkeVariablen.get(index)).getType();
		typeLeftSide.setText(type);
		typeRightSide.setText(type);
		rightVariables.removeAll();
		if (linkeVariablen.size() > 1) {

			for (int i = 0; i < linkeVariablen.size(); i++) {
				VariableDeclaration v =
					(VariableDeclaration) linkeVariablen.get(i);
				String name = v.getVarName();
				String varType = v.getType();
				if (varType.equals(typeLeftSide.getText())
					&& !name.equals(leftVariables.getItem(index))) {
					rightVariables.add(name);
				}
			}
			rightVariables.select(0);
		}
	}

	/** Auto-generated event handler method */
	protected void OKMouseDown(MouseEvent evt) {

		int index = leftVariables.getSelectionIndex();
		leftName = leftVariables.getItem(index);
		leftType = typeLeftSide.getText();
		index = operator.getSelectionIndex();
		op = operator.getItem(index);
		//if variable on the right side was selected
		if (asVarDec.getSelection()) {
			int selectionIndex = rightVariables.getSelectionIndex();
			if(selectionIndex > -1){
			rightName =
				rightVariables.getItem(rightVariables.getSelectionIndex());
			rightType = typeRightSide.getText();
			}
		} else {
			//otherwise take the value
			rightName = rightValue.getText();
		}

		if (rightName.equals("") || rightName == null || leftName == null) {
			MessageBox msg =
				new MessageBox(dialogShell, SWT.ICON_WARNING | SWT.OK);

			msg.setMessage("Der Wert auf der rechten Seite der Bedingung fehlt");
			msg.open();
			return;
		}
		//check double VariableNmaes
		if (leftName.equals(rightName)) {
			MessageBox msg =
				new MessageBox(dialogShell, SWT.ICON_INFORMATION | SWT.OK);

			msg.setMessage("Die Variablen mssen unterschiedlich sein");
			msg.open();
			rightValue.setText("");
			rightValue.setFocus();
			return;
		}

		dialogShell.close();

	}

	/** Auto-generated event handler method */
	protected void CancelMouseDown(MouseEvent evt) {
		canceled = true;
		dialogShell.close();
	}
	/**
	 * Returns the leftVariableName
	 * @return the variable name
	 */
	public String getLeftName() {
		return leftName;
	}

	/**
	 * Returns the Type of the left side
	 * @return the type of the left side
	 */
	public String getLeftType() {
		return leftType;
	}

	/**
	 * Returns the value of the right side.
	 * @return value of the right side
	 */
	public String getRightName() {
		return rightName;
	}

	/**
	 * Returns the type of the right side.
	 * @return type of the right side
	 */
	public String getRightType() {
		return rightType;
	}

	/**
	 * @return
	 */
	public String getValue() {
		return value;
	}

	/**
	 * Returns the Operationkind.
	 * @return the operationkind
	 */
	public String getOp() {
		return op;
	}

	/**
	 * Indicates whether the dialog was aborted.
	 * @return isCancelled
	 */
	public boolean isCanceled() {
		return canceled;
	}

	private boolean asVariableDeclaration = false;
	/** Auto-generated event handler method */
	protected void asVarDecWidgetSelected(SelectionEvent evt) {
		asVariableDeclaration = true;
		typeRightSide.setVisible(asVarDec.getSelection());
		rightVariables.setVisible(asVarDec.getSelection());
		rightValue.setVisible(!asVarDec.getSelection());

	}
}
