package vocleditor.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import vocleditor.model.NavExpConstants;

/**
 * This code was generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * *************************************
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
 * for this machine, so Jigloo or this code cannot be used legally
 * for any corporate or commercial purpose.
 * *************************************
 */
/**
 * 
 * Class : NewConstraintDialog <br/>Package : vocleditor.dialog <br/>Project :
 * VOCLEditor <br/>Created On : 26.06.2004 <br/>Description : This class
 * provides a dialog for creating constraints <br/>
 * 
 * @author Gruppe 1: Stefan Hnsgen, Andre Hernich, Maximilian Kern, Sebastian
 *         Russin <br>
 */
public class NewConstraintDialog extends org.eclipse.swt.widgets.Dialog {
	private Label label2;

	private Text constraintKindLabel;

	private Label label1;

	private Text contextTyp;

	private Combo typeCombo;

	private Button button1;

	private Button okButton;

	private Text contextName;

	private Text text1;

	private Label label3;

	private Shell dialogShell;

	private boolean isCancelled;
	
	private String title;

	/**
	 * @param title The title to set.
	 */
	public void setTitle(String title) {
		this.title = title;
	}
	private String name = "";

	private String context_name = "";

	private String context_type = "";

	private String type = "";

	private boolean isClassifier = true;
	
	private boolean isEdit = false;

	/**
	 * Constructor.
	 * 
	 * @param parent
	 *            the parent shell
	 */
	public NewConstraintDialog(Shell parent) {
		super(parent, SWT.NULL);
	}

	/**
	 * Opens the Dialog Shell. Auto-generated code - any changes you make will
	 * disappear.
	 */
	public void open() {
		try {
			preInitGUI();

			Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM
					| SWT.APPLICATION_MODAL);
			dialogShell.setText(getText());
			label3 = new Label(dialogShell, SWT.NULL);
			text1 = new Text(dialogShell, SWT.BORDER);
			contextName = new Text(dialogShell, SWT.BORDER);
			typeCombo = new Combo(dialogShell, SWT.NULL);
			okButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			button1 = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			contextTyp = new Text(dialogShell, SWT.BORDER);
			label1 = new Label(dialogShell, SWT.NULL);
			constraintKindLabel = new Text(dialogShell, SWT.NULL);
			label2 = new Label(dialogShell, SWT.NULL);

			dialogShell.setText("Create a constraint");
			dialogShell.setSize(324, 264);

			label3.setText("context :  type");
			label3.setAlignment(SWT.LEFT);
			label3.setEnabled(true);
			label3.setBounds(15, 140, 102, 20);

			text1.setBounds(130, 20, 150, 25);
			final Color text1foreground = new Color(Display.getDefault(), 0, 0,
					0);
			text1.setForeground(text1foreground);

			contextName.setBounds(130, 105, 150, 25);

			typeCombo.setBounds(152, 60, 129, 21);

			okButton.setText("Okay");
			okButton.setSize(new org.eclipse.swt.graphics.Point(80, 25));
			okButton.setBounds(new org.eclipse.swt.graphics.Rectangle(16, 180,
					80, 25));
			okButton.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					okButtonMouseDown(evt);
				}
			});

			button1.setText("Cancel");
			button1.setSize(new org.eclipse.swt.graphics.Point(80, 25));
			button1.setBounds(new org.eclipse.swt.graphics.Rectangle(110, 180,
					80, 25));
			button1.addMouseListener(new MouseAdapter() {
				public void mouseDown(MouseEvent evt) {
					button1MouseDown(evt);
				}
			});

			contextTyp.setBounds(130, 140, 150, 25);

			label1.setText("context :  name");
			label1.setAlignment(SWT.LEFT);
			label1.setEnabled(true);
			label1.setBounds(15, 105, 113, 20);

			constraintKindLabel.setText("constraint kind: ");
			constraintKindLabel.setDoubleClickEnabled(false);
			constraintKindLabel.setBounds(15, 60, 104, 18);
			final Color constraintKindLabelbackground = new Color(Display
					.getDefault(), 224, 223, 227);
			constraintKindLabel.setBackground(constraintKindLabelbackground);

			label2.setText("name (optional)");
			label2.setBounds(15, 20, 92, 16);
			dialogShell.setLayout(null);
			dialogShell.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					text1foreground.dispose();
					constraintKindLabelbackground.dispose();
				}
			});
			Rectangle bounds = dialogShell.computeTrim(0, 0, 304, 223);
			dialogShell.setSize(bounds.width, bounds.height);
			postInitGUI();
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/** Add your pre-init code in here */
	public void preInitGUI() {
	}

	/**
	 * @param context_name
	 *            The context_name to set.
	 */
	public void setContext_name(String context_name) {
		this.context_name = context_name;
	}

	/**
	 * @param context_type
	 *            The context_type to set.
	 */
	public void setContext_type(String context_type) {
		this.context_type = context_type;
	}

	/**
	 * @param name
	 *            The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}

	/** Add your post-init code in here */
	public void postInitGUI() {
		//put the constraint types into the modell
		for (int x = 0; x < NavExpConstants.CONSTRAINT_TYPES.length; x++) {
			typeCombo.add(NavExpConstants.CONSTRAINT_TYPES[x]);
		}
		typeCombo.select(0);
		if (isEdit) {
			dialogShell.setText(title);
			contextName.setText(context_name);
			contextTyp.setText(context_type);
			text1.setText(name);
			if (type.equals("INV"))
				typeCombo.select(0);
			else if (type.equals("PRE")) {
				typeCombo.select(1);
			} else
				typeCombo.select(2);
		}

	}

	/** Auto-generated event handler method */
	protected void okButtonMouseDown(MouseEvent evt) {
		name = text1.getText();
		context_name = contextName.getText();
		context_type = contextTyp.getText();
		type = (typeCombo.getItem(typeCombo.getSelectionIndex())).trim();
		//kein Contexttyp vorhanden
		if (context_type.length() == 0) {
			MessageBox msg = new MessageBox(dialogShell, SWT.ICON_INFORMATION
					| SWT.OK);
			msg.setText("Dialog nicht vollstndig");
			msg.setMessage("Sie mssen mindestens einen Contexttyp angeben");
			msg.open();
			return;

		} else {
			isClassifier = type.toLowerCase().equals("inv");
		}

		isCancelled = false;
		dialogShell.close();
	}

	public boolean isCancelled() {
		return isCancelled;
	}

	/** Auto-generated event handler method */
	protected void button1MouseDown(MouseEvent evt) {
		isCancelled = true;
		dialogShell.close();
	}

	/**
	 * Returns the Name of the Constraint.
	 * 
	 * @return constraint name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Returns the kind of the Constraint.
	 * 
	 * @return the constraint kind
	 */
	public String getType() {
		return type;
	}

	/**
	 * Returns whether this constraint belongs to a method or classifier.
	 * 
	 * @return isClassifier
	 */
	public boolean isClassifier() {
		return this.isClassifier;
	}

	/** Auto-generated event handler method */
	protected void condButtonWidgetSelected(SelectionEvent evt) {

	}

	/**
	 * Returns the name of the Constraintcontext.
	 * 
	 * @return context name
	 */
	public String getContext_name() {
		return context_name;
	}

	/**
	 * Returns the type of the Constraintcontext.
	 * 
	 * @return context type
	 */
	public String getContext_type() {
		return context_type;
	}
	/**
	 * @return Returns the isEdit.
	 */
	public boolean isEdit() {
		return isEdit;
	}
	/**
	 * @param isEdit The isEdit to set.
	 */
	public void setEdit(boolean isEdit) {
		this.isEdit = isEdit;
	}
	/**
	 * @param type The type to set.
	 */
	public void setType(String type) {
		this.type = type;
	}
}