package vocleditor.edit;

import org.eclipse.gef.commands.Command;

import VOCLModel.AssociationEndRole;


/**
 * 
 * Class       : AssociationEndRoleCommand<br/>
 * Package     : vocleditor.edit<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : Class for creating Labels at AssociationEndRoles.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class AssociationEndRoleCommand extends Command
{
	private String newName, oldName;
	private AssociationEndRole label;

	/**
	 * Constructor.
	 * @param l
	 * @param s
	 */
	public AssociationEndRoleCommand(AssociationEndRole l, String s)
	{
		label = l;
		if (s != null)
		{
			newName = s;
		}
		else
		{
			newName = "";
		} 
	}

	/** 
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute()
	{
		oldName = label.getName();
		label.setName(newName);
	}

	/** 
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo()
	{
		label.setName(oldName);
	}
	
	
}
