package vocleditor.edit;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gef.tools.DirectEditManager;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Text;

/**
 * 
 * Class       : AssociationEndRoleEditManager<br/>
 * Package     : vocleditor.edit<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : Creates an EditManager for AssociationEndRoles.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class AssociationEndRoleEditManager extends DirectEditManager
{

	Font scaledFont;
	private VerifyListener verifyListener;

	/**
	 * Constructor.
	 * @param source
	 * @param editorType
	 * @param locator
	 */
	public AssociationEndRoleEditManager(GraphicalEditPart source, Class editorType, CellEditorLocator locator)
	{
		super(source, editorType, locator);
	}

	/**
	 * @see org.eclipse.gef.tools.DirectEditManager#bringDown()
	 */
	protected void bringDown()
	{
		//This method might be re-entered when super.bringDown() is called.
		Font disposeFont = scaledFont;
		scaledFont = null;
		super.bringDown();
		if (disposeFont != null)
			disposeFont.dispose();
	}

	/**
	 * @see org.eclipse.gef.tools.DirectEditManager#initCellEditor()
	 */
	protected void initCellEditor()
	{
		Text text = (Text)getCellEditor().getControl();
		Label label = (Label) ((GraphicalEditPart)getEditPart()).getFigure();
		String initialLabelText = label.getText();
		getCellEditor().setValue(initialLabelText);
		IFigure figure = ((GraphicalEditPart)getEditPart()).getFigure();
		scaledFont = figure.getFont();
		FontData data = scaledFont.getFontData()[0];
		Dimension fontSize = new Dimension(0, data.getHeight());
		label.translateToAbsolute(fontSize);
		data.setHeight(fontSize.height);
		scaledFont = new Font(null, data);

		text.setFont(scaledFont);
		text.selectAll();
	}
}