package vocleditor.edit;


import org.eclipse.gef.EditPart;
import org.eclipse.gef.tools.DragEditPartsTracker;
import vocleditor.edit.parts.AssociationRoleEditPart;

/**
 * 
 * Class       : AssociationEndRoleTracker<br/>
 * Package     : vocleditor.edit<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 26.06.2004<br/>
 * Description : Creates a Tracker for AssociationEndRoles<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class AssociationEndRoleTracker extends DragEditPartsTracker
{

	AssociationRoleEditPart connection;

	/**
	 * Constructor.
	 * @param source
	 * @param connection the current AssociationRoleEditPart
	 */
	public AssociationEndRoleTracker(EditPart source, AssociationRoleEditPart connection)
	{
		super(source);
		this.connection = connection;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.tools.TargetingTool#getTargetEditPart()
	 */
	protected EditPart getTargetEditPart()
	{
		return connection;
	}
}