/*
 * Created on 07.06.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vocleditor.figures;



import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.handles.HandleBounds;


/**
 * 
 * Class       : NavExpContainerFigure<br/>
 * Package     : vocleditor.edit.parts<br/>
 * Project     : VOCLEditor<br/>
 * Created On  : 22.05.2004<br/>
 * Description : Creates a container for NavigationExpressions where ClassifierNodes can be placed.<br/>
 * @author Gruppe 1: Stefan Hnsgen, 
 * 					 Andre Hernich,
 * 			 		 Maximilian Kern,
 *		 			 Sebastian Russin<br>
 */
public class NavExpContainerFigure
	extends VOCLExpFigure
	implements HandleBounds {

	private ConditionFigure condFigure = null;
	private PolylineConnection dashedLine;
	private XYLayout layout;
	
	
	/**
	 * Creates a new NavExpContainerFigure. 
	 */
	public NavExpContainerFigure() {
		layout = new XYLayout();
		setLayoutManager(layout);
//		setBackgroundColor(ColorConstants.cyan);
		setOutline(false);
		dashedLine = new PolylineConnection();
		dashedLine.setLineStyle(Graphics.LINE_DASH);
		add(dashedLine);
		setBackgroundColor(ColorConstants.listBackground);
		setOpaque(true);

	}

	/**
	 * @see org.eclipse.draw2d.IFigure#add(org.eclipse.draw2d.IFigure, java.lang.Object, int)
	 */
	public void add(IFigure figure, Object constraint, int index) {
		if (figure instanceof ConditionFigure) {
			condFigure = (ConditionFigure) figure;
			super.add(figure, constraint, index);

		} else
			super.add(figure, constraint, index);
	}

	/*
	* @see org.eclipse.gef.handles.HandleBounds#getHandleBounds()
	*/
	public Rectangle getHandleBounds() {
		return getBounds().getCropped(new Insets(2, 0, 2, 0));
	}

	int width = 0;
	int height = 0;
	/**
	* @see org.eclipse.draw2d.IFigure#validate()
	*/
	public void validate() {
		width = getSize().width;
		height = getSize().height;
		if (condFigure != null) {
			if (!condFigure.getCondition().equals("")) {
				dashedLine.setStart(new Point(0, height - 30));
				dashedLine.setEnd(new Point(width, height - 30));
				layout.setConstraint(
					condFigure,
					new Rectangle(0, height - 30, width, 30));
				
			} else {
				layout.setConstraint(this, new Rectangle(0, 0, width, height));
				dashedLine.setStart(new Point(0, 0));
				dashedLine.setEnd(new Point(0, 0));
				layout.setConstraint(condFigure, new Rectangle(0, 0, 0, 0));
			}
		} else {
			layout.setConstraint(this, new Rectangle(0, 0, width, height));
			dashedLine.setStart(new Point(0, 0));
			dashedLine.setEnd(new Point(0, 0));
			layout.setConstraint(condFigure, new Rectangle(0, 0, 0, 0));
		}
		super.validate();

	}

	/**
	 * @see org.eclipse.draw2d.Figure#useLocalCoordinates()
	 */
	protected boolean useLocalCoordinates() {
		return true;
	}


	/**
	 * @see vocleditor.figures.VOCLExpFigure#returnBereich()
	 */
	public int returnBereich() {
		return -1;
	}

	/**
	 * @see vocleditor.figures.VOCLExpFigure#getClassifierLocation()
	 */
	public Point getClassifierLocation() {
		return null;
	}

}
