package vocleditor.figures;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;

public class UMLClassFigure extends Figure {
	public static Color classColor = new Color(null, 255, 255, 206);
	private CompartmentFigure attributeFigure = new CompartmentFigure();
	private CompartmentFigure methodFigure = new CompartmentFigure();
	Label classifier;
	
	public UMLClassFigure(String name) {
		Font classFont = //new Font(null, "Arial", 12, SWT.BOLD);
					new Font(null, "Sans", 12, SWT.BOLD);
		ToolbarLayout layout = new ToolbarLayout();
		setLayoutManager(layout);
		setBorder(new LineBorder(ColorConstants.black, 1));
		setBackgroundColor(classColor);
		setOpaque(true);
		classifier = new Label(name);
		classifier.setFont(classFont);
		add(classifier);

	}
	
	public void setClassifierName(String name){
		classifier.setText(name);
	}
	
	public void setVariableName(String name){
		String text = classifier.getText();
		text = name + " : " + text;
		classifier.setText(text);
	}
	
	public CompartmentFigure getAttributesCompartment() {
		return attributeFigure;
	}
	public CompartmentFigure getMethodsCompartment() {
		return methodFigure;
	}
}
