/* 
 * $Id: IElementStatusConstants.java,v 1.2 2004/11/09 09:49:37 haensgen Exp $
 */
 
package VoclToOclConverter;

/**
 * Defines constants used as (error) codes in ElementStatus instances.
 * 
 * @see ElementStatus
 */
public interface IElementStatusConstants {
	
	/**
	 * A constraint has no context.
	 */
	public static final int CONSTRAINT__NO_CONTEXT = 201;
	
	/**
	 * A constraint has no navigation expression.
	 */
	public static final int CONSTRAINT__NO_VOCL_EXPRESSION = 202;
	
	/**
	 * A context has no type.
	 */
	public static final int CONTEXT__NO_TYPE = 301;
	
	/**
	 * A condition has no operation.
	 */
	public static final int CONDITION__NO_OPERATION = 401;
	
	/**
	 * A condition has no left variable declaration assigned.
	 */
	public static final int CONDITION__NO_LEFT_VARIABLE_DECLARATION = 402;
	
	/**
	 * A navigation expression has no self variable declaration.
	 */
	public static final int NAVEXP__NO_SELF_VARIABLE_DECLARATION = 501;
	
	/**
	 * A navigation expression has more than one self variable declaration.
	 */
	public static final int NAVEXP__MORE_THAN_ONE_SELF_VARIABLE_DECLARATION = 502;

	/**
	 * A variable declaration has no type.
	 */
	public static final int VARIABLE_DECLARATION__NO_TYPE = 601;
	
	/**
	 * A variable declaration has no type.
	 */
	public static final int VARIABLE_DECLARATION__NO_NAME = 602;
}
